/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifndef _tVScrollArea_h
#define _tVScrollArea_h

#ifdef __GNUC__
#pragma interface
#endif


#include "DrawArea.h"
#include <Xm/ScrolledW.h>

class xwVScrollArea : public xwDrawArea
   {private:
	Widget	  hscroll;
	Widget	  vscroll;
	Widget scrollarea;

	static void cbHScroll(Widget, XtPointer, XtPointer);
	static void cbVScroll(Widget, XtPointer, XtPointer);

	int   oldX,   oldY;
	int rangeX, rangeY;

	static void cbResize(Widget, XtPointer, XtPointer);

    protected:
	void initScroll();
	inline xwVScrollArea() { }

    public:
	xwVScrollArea(xwWidget* p, int x1, int y1, int x2, int y2);
	xwVScrollArea(xwWidget* p);
	~xwVScrollArea();

	void setOffsets(int  x, int  y);
	void getOffsets(int* x, int* y);

	void setRange(int  width, int  height);
	void getRange(int* width, int* height);

	void getView(int* x, int* y, int* width, int* height);
   };

#endif

